/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// BackLogWindow.cxx

#include	<winsock2.h>
#include	<crtdbg.h>

#include	"lgWindows.h"
#include	"BackLogWindow.h"
#include	"Witalk2.h"
#include	"lgFiles.h"
#include	"DialogURL.h"
#include	"WinDLL.h"

#include	<string>
using namespace std;


ATOM BackLogWindow::rrcex = NULL;

BackLogWindow::BackLogWindow()
:m_pWItalk2( NULL ), m_hWnd( NULL ), m_pView( NULL ), m_procItalkView( NULL )
{
}
BackLogWindow::~BackLogWindow()
{
	delete m_pView;
}
BOOL BackLogWindow::create( HINSTANCE hInst, WItalk2* pwt2 )
{
	m_pWItalk2 = pwt2;

	if (!rrcex) {
		WNDCLASSEX	wndclass;
		wndclass.cbSize			= sizeof(WNDCLASSEX);
		wndclass.style			= CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc	= BackLogWindow::WndProc;
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= 0;
		wndclass.hInstance		= hInst;
		wndclass.hIcon			= LoadIcon( hInst , MAKEINTRESOURCE(rIconWItalk2Backlog) );
		wndclass.hCursor		= LoadCursor( NULL, IDC_ARROW );
		wndclass.hbrBackground	= (HBRUSH)GetStockObject( COLOR_BACKGROUND );
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= getClassName();
		wndclass.hIconSm		= LoadIcon( hInst , MAKEINTRESOURCE(rIconWItalk2BacklogSm) );
		rrcex = RegisterClassEx( &wndclass );
		_ASSERT(rrcex);
	}

	// IWi WItalk2 EBhẼTCY擾
	int		witalkWidth = m_pWItalk2->mainWindowWidth, witalkHeight = m_pWItalk2->mainWindowHeight;

	std::string str = "BackLog [";
	if (m_pWItalk2->getItalkHost()){
		char	wtitle[BUFSIZE];
		sprintf(wtitle, "%s:%d / %d", m_pWItalk2->getItalkHost(), m_pWItalk2->getItalkPort(), m_pWItalk2->backlogList.size()+1); 
		str += wtitle;
	}
	str += "]";
	m_hWnd = CreateWindowEx(NULL, getClassName() ,str.c_str(),
							WS_OVERLAPPEDWINDOW,
							CW_USEDEFAULT, CW_USEDEFAULT, witalkWidth, witalkHeight / 2, NULL, NULL, hInst, NULL );
	_ASSERT(m_hWnd);
	SetWindowLongPtr( m_hWnd, GWLP_USERDATA, (LONG_PTR)this );
	

	if( !onCreate() ){
		return FALSE;
	}

	ShowWindow( m_hWnd, SW_SHOW );
	UpdateWindow( m_hWnd );
		
	OutputDebugString( "BackLogWindow created\n" );
	return TRUE;
}
LRESULT CALLBACK BackLogWindow::WndProc(HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
	BackLogWindow* p = (BackLogWindow*)GetWindowLongPtr(hwnd, GWLP_USERDATA);
	if( p ){
		return p->dispatch(hwnd, message, wParam, lParam);
	}else{
		return DefWindowProc(hwnd, message, wParam, lParam);
	}
}
LRESULT BackLogWindow::dispatch(HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
	switch (message)
	{
//	case WM_SETFOCUS:
//		{
//			if (!m_pWItalk2->is_backloging) SetFocus(m_pView->Re.Hwnd());
//			return 0;
//		}
	case WM_SIZE:				/* EBhETCY */
		{
			int		width = LOWORD(lParam), height = HIWORD(lParam);
			MoveWindow(m_pView->Re.Hwnd(), 0, 0, width, height, true);			
			/* ^XNgC */
			switch(wParam){
			case SIZE_MINIMIZED:
				if (m_pWItalk2->tasktrayIcon && m_pWItalk2->tasktrayStore){
					// WS_EX_TOOLWINDOW ݒ肵 ALT+TAB Ő؂ւȂ悤ɂ
					SetWindowLongPtr(hwnd, GWL_EXSTYLE, (GetWindowLongPtr(hwnd, GWL_EXSTYLE) | WS_EX_TOOLWINDOW) & (~WS_EX_APPWINDOW));
					// ^XNo[폜
					taskbarDelete(hwnd);
				}
				break;
			case SIZE_RESTORED:
				// ^XNo[ɍēo^
				taskbarAdd(hwnd);
				break;
			}
			return 0;
		}
	case WM_CLOSE:
		OutputDebugString(" BackLogWindow WM_CLOSE\n" );
		if( m_pWItalk2 && m_pWItalk2->getCurrentLogWindow() == this ){
			return 0;
		}
		delete m_pView;
		m_pView = NULL;
		break;
	case WM_DESTROY:
		OutputDebugString(" BackLogWindow WM_DESTROY\n" );
		SetWindowLongPtr( hwnd, GWLP_USERDATA, 0 );

		if (m_pWItalk2->backlogList.size()){
			for (unsigned int i = 0; i < m_pWItalk2->backlogList.size(); i++)
				if (m_pWItalk2->backlogList[i] == this){ m_pWItalk2->backlogList[i] = 0; }
		}

		delete this;

		return 0;
	case WM_NOTIFY:
		{
			HWND	notify_hwndfrom = ((LPNMHDR)lParam)->hwndFrom;
			UINT	notify_idfrom = ((LPNMHDR)lParam)->idFrom;
			UINT	notify_code = ((LPNMHDR)lParam)->code;
			if (notify_code != EN_LINK) break;
			UINT	orgmsg = ((ENLINK*)lParam)->msg;
			switch(orgmsg){
			case WM_LBUTTONDOWN:
				if (DialogURL::url_clickmode) break;
			case WM_LBUTTONDBLCLK:
				CHARRANGE	chrg = ((ENLINK*)lParam)->chrg;
				char*		txtbuf_mb = new char[(chrg.cpMax - chrg.cpMin + 16)*2];
				CHARRANGE	orgsel;
				SendMessage(notify_hwndfrom, EM_EXGETSEL, 0, (LPARAM)&orgsel);
				SendMessage(notify_hwndfrom, EM_EXSETSEL, 0, (LPARAM)&chrg);
				SendMessage(notify_hwndfrom, EM_GETSELTEXT, 0, (LPARAM)txtbuf_mb);
				SendMessage(notify_hwndfrom, EM_EXSETSEL, 0, (LPARAM)&orgsel);
				lgFiles::OpenURL(txtbuf_mb, DialogURL::url_bufexecmode);
				delete [] txtbuf_mb;
			}
			break;
		}

	}
	return DefWindowProc (hwnd , message , wParam,lParam);

}
BOOL BackLogWindow::onCreate()
{
	m_pView = new ItalkView( m_hWnd,m_pWItalk2, &witalk2_ptr->foColorInput, &witalk2_ptr->bkColorLog, ES_AUTOVSCROLL | ES_READONLY);

	m_pView->setParentPointer( m_pWItalk2 );
	m_pView->m_bPostQuitMsg = FALSE;

	m_pView->ReadRegistry(true);
#ifdef	USE_EMACS_KEYBIND
	m_pView->Re.EnableEmacsBinding(m_pWItalk2->statusbar);
	m_pWItalk2->iv_set_keybinding(m_pView);

	lgcRichEdit::KeyBinding k;
	if (m_pWItalk2->menu.IsChecked(rCommandOtherEmacsKeyBinding)){
		k = lgcRichEdit::KeyBindingEmacs;
	} else {
		k = lgcRichEdit::KeyBindingWindows;
	}
	m_pView->Re.SelectKeyBinding(k);
#endif

	m_pWItalk2->backlogList.push_back(this);	// obNOXgɒǉ

	m_procItalkView = (WNDPROC)GetWindowLongPtr( m_pView->Re.Hwnd(), GWLP_WNDPROC );
	m_mainWndProc = (WNDPROC)SetWindowLongPtr( m_hWnd, GWLP_WNDPROC, (LONG_PTR)MainWndProc );
	m_pView->setSubclass(false);
	SetWindowLongPtr( m_pView->Re.Hwnd(), GWLP_WNDPROC, (LONG_PTR)ViewWndProc );

	return TRUE;
}
void BackLogWindow::AddLog( const wchar_t* text, BOOL auto_scroll )
{
	_ASSERT(m_pView);
	m_pView->AddText( text, auto_scroll );
}

// obNOEBhE{̂TuNX =====================================
LRESULT CALLBACK BackLogWindow::MainWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	BackLogWindow* pwnd = (BackLogWindow*)GetWindowLongPtr(hwnd, GWLP_USERDATA);

	if (!pwnd) return DefWindowProc(hwnd, message, wParam, lParam);

	if (message == WM_COMMAND) switch(LOWORD(wParam)){
	// ҏW (JbgAhy[Xgn) bZ[W
	case rCommandEditUndo:				pwnd->m_pView->Re.Undo(); break;
	case rCommandEditCut:
	case rCommandEditCopy:				pwnd->m_pView->Re.Copy(); break;
	case rCommandKeyDown:		/* L[ꂽ */
		{
			pwnd->m_pWItalk2->send_vkey(pwnd->m_pView->Re.Hwnd(), VK_DOWN);
			return 0;
		}
	// Alt+PgUp / Alt+PgDn (OEBhEXN[)
	case rCommandKeyMNext:
		{
			pwnd->m_pWItalk2->send_vkey(pwnd->m_pView->Re.Hwnd(), VK_NEXT);
			return 0;
		}
	case rCommandKeyMPrior:
		{
			pwnd->m_pWItalk2->send_vkey(pwnd->m_pView->Re.Hwnd(), VK_PRIOR);
			return 0;
		}
	
		MessageBox(0, "", "", MB_OK);
	}

	return CallWindowProc(pwnd->m_mainWndProc, hwnd, message, wParam, lParam);
}

// ENbNj[o ===================================================
void BackLogWindow::popupRbuttonmenuBacklog(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HMENU&	hPopupMenu = witalk2_ptr->hPopupMenu;
	POINT	point;

	BackLogWindow* pwnd = (BackLogWindow*)GetWindowLongPtr(GetParent(hwnd), GWLP_USERDATA);

	if( !pwnd ) return;

	point.x = LOWORD(lParam), point.y = HIWORD(lParam);
	ClientToScreen(hwnd, &point);

	EnableMenuItem(hPopupMenu, rCommandLogAutoScroll, MF_GRAYED | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandOtherUsers, MF_GRAYED | MF_BYCOMMAND);

	EnableMenuItem(hPopupMenu, rCommandClearBuffer, MF_GRAYED | MF_BYCOMMAND);

	// CheckMenuItem(hPopupMenu, rCommandLogAutoScroll, ((pwnd->twpd->doesAutoScroll) ? (MF_CHECKED) : (0)) | MF_BYCOMMAND);
	CheckMenuItem(hPopupMenu, rCommandLogAutoScroll, MF_CHECKED | MF_BYCOMMAND);

	bool	clipext = IsClipboardFormatAvailable(CF_TEXT) || IsClipboardFormatAvailable(CF_OEMTEXT) || IsClipboardFormatAvailable(CF_UNICODETEXT);

	EnableMenuItem(hPopupMenu, rCommandEditPaste, MF_GRAYED | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandEditQuotedPaste, MF_GRAYED | MF_BYCOMMAND);

	EnableMenuItem(hPopupMenu, rCommandEditCut, MF_GRAYED | MF_BYCOMMAND);

	bool	bufselected = !!pwnd->m_pView->Re.IsSelected();
	EnableMenuItem(hPopupMenu, rCommandEditCopy, (bufselected ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	bool	selsend = bufselected && witalk2_ptr->isConnectionActive;
	EnableMenuItem(hPopupMenu,  rCommandEditSendToItalk, (selsend ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	bool	clipsend = clipext && witalk2_ptr->isConnectionActive;
	EnableMenuItem(hPopupMenu, rCommandEditPasteSendToItalk, (clipsend ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandEditQuotedPasteSendToItalk, (clipsend ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	// Waffle 0.2.2beta6: Ŝߑ΍
	SetForegroundWindow(hwnd);
	TrackPopupMenu(hPopupMenu, 0, point.x, point.y, 0, pwnd->m_hWnd, NULL);
	PostMessage(hwnd, WM_NULL, 0, 0);

	return;
}

// Oobt@TuNX =================================================
//
LRESULT CALLBACK BackLogWindow::ViewWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	// b`GfBbg̐e BackLogWindow
	BackLogWindow* pwnd = (BackLogWindow*)GetWindowLongPtr(GetParent(hwnd), GWLP_USERDATA);

	if( !pwnd ){
		return DefWindowProc (hwnd , message , wParam,lParam);
	}
	switch(message){
	case WM_KEYDOWN:
		{
			POINT	caretPos;
			if (wParam != 0x5D || lParam != 0x15D0001) break;
			if (GetCaretPos(&caretPos) == 0) break;
			lParam = (caretPos.y & 0xFFFF) << 16 | (caretPos.x & 0xFFFF);
		}
	case WM_RBUTTONDOWN:
		popupRbuttonmenuBacklog(hwnd, message, wParam, lParam);
		return 0;
	case WM_SETFOCUS:
		//if (lParam != 0x4624 && lParam != 0x4624*2) twpd->inFocus_iv_log_private = true;
		break;
	case WM_KILLFOCUS:
		//if (lParam != 0x4624 && lParam != 0x4624*2) twpd->inFocus_iv_log_private = false;
		break;
	}
	
	return CallWindowProc(pwnd->m_procItalkView , hwnd, message, wParam, lParam);
	
}
