/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// DialogOther.cxx


#include	<winsock2.h>
#include <shlobj.h>

#include "Dialog.h"
#include "lgDialog.h"
#include "lgFiles.h"
#include "witalk2.h"
#include "ProfileManager.h"
#include "WinDLL.h"

extern	WItalk2* witalk2_ptr;
extern	char iniFileName[BUFSIZE];

class DialogOther : public lgDialog
{
	ProfileManager* m_pProfileManager;
	/*lgRegistry registry;*/
  
	void set_all(void)
	{
		BOOL does_enable = Button_GetCheck(Hwnd(rCheckDoesSaveLog));
		EnableWindow(Hwnd(rEditLogSaveFolder),         does_enable);
		EnableWindow(Hwnd(rButtonLogSaveFolderBrowse), does_enable);
		EnableWindow(Hwnd(rCheckLogSavePrivateOnly),   does_enable);
		EnableWindow(Hwnd(rStaticLogSaveFolder),       does_enable);
	}
  
public:
  DialogOther(HWND _hwnd)
    : lgDialog(_hwnd)/*, registry(REGISTRY_ROOT)*/
  { }
  
  // WM_INITDIALOG
  BOOL wmInitDialog(HWND /* focus */, LPARAM  lParam )
  {
		if( lParam ){
			PROPSHEETPAGE* pProp = (PROPSHEETPAGE*)lParam;
			m_pProfileManager = (ProfileManager*)pProp->lParam;
		}
		_ASSERT( m_pProfileManager != NULL );

    int value;
    char buf[BUFSIZE];
    

    m_pProfileManager->Read("LogSaveFolder", buf, sizeof(buf), windll.logSaveFolder.c_str());
    SetWindowText(rEditLogSaveFolder, buf);
    m_pProfileManager->Read("DoesSaveLog", value, FALSE);
    Button_SetCheck(Hwnd(rCheckDoesSaveLog), value);
    m_pProfileManager->Read("LogSavePrivateOnly", value, TRUE);
    Button_SetCheck(Hwnd(rCheckLogSavePrivateOnly), value);
    
    m_pProfileManager->Read("QuotationMark", buf, sizeof(buf), "> ");
    SetWindowText(rEditQuotationMark, buf);

	m_pProfileManager->Read("INISaveFolder", buf, sizeof(buf), ".\\");
	SetWindowText(rEditINISaveFolder, buf);

	// Waffle 0.2.0b: obNOłXN[~Ȃ
    m_pProfileManager->Read("NonStopAutoScrollInBacklog", value, false);
	Button_SetCheck(Hwnd(rNonStopAutoScrollInBacklog), value);

	// SPT0.0/Waffle 0.2.1b: obNO̕ʃEBhE\
	m_pProfileManager->Read("BacklogSplit", value, false);
	Button_SetCheck(Hwnd(rCheckBacklogSplit), value);

	// JIS-patch ̖
	m_pProfileManager->Read("SendJIS", value, false);
	Button_SetCheck(Hwnd(rCheckSendJIS), value);

	// dN}ݒ
	// WXgǂ
	lgRegistry reg( REGISTRY_ROOT );
	reg.Read("MultiProcess", value, false);
	Button_SetCheck(Hwnd(rCheckInhibitDupProcess), value);

    set_all();
    return TRUE;
  }
  
  // OK ͍XV
  BOOL wmNotify_psnApply(void)
  {
    char buf[BUFSIZE];

	// Waffle 0.2.1f: INI t@CۑfBNg
	GetWindowText(rEditINISaveFolder, buf, sizeof(buf));
	m_pProfileManager->Write("INISaveFolder", buf);
	{
		char	inifname[BUFSIZE];
		if (buf[strlen(buf)-1] == 0x5C && strlen(buf) > 1) buf[strlen(buf)-1] = 0;
		sprintf(inifname, "%s\\waffle.ini", buf);
		//iniFileName = new char[strlen(inifname)+1];
		strcpy(iniFileName, inifname);
	}
    
    m_pProfileManager->Write("DoesSaveLog", Button_GetCheck(Hwnd(rCheckDoesSaveLog)));
    m_pProfileManager->Write("LogSavePrivateOnly",
		   Button_GetCheck(Hwnd(rCheckLogSavePrivateOnly)));
    GetWindowText(rEditLogSaveFolder, buf, sizeof(buf));
    m_pProfileManager->Write("LogSaveFolder", buf);
    
    GetWindowText(rEditQuotationMark, buf, sizeof(buf));
    m_pProfileManager->Write("QuotationMark", buf);

	// Waffle 0.2.0b: obNOłXN[~Ȃ
	m_pProfileManager->Write("NonStopAutoScrollInBacklog", Button_GetCheck(Hwnd(rNonStopAutoScrollInBacklog)));

	// SPT0.0/Waffle 0.2.1b: obNO̕ʃEBhE\
	m_pProfileManager->Write("BacklogSplit", Button_GetCheck(Hwnd(rCheckBacklogSplit)));

	// JIS-patch 
	m_pProfileManager->Write("SendJIS", Button_GetCheck(Hwnd(rCheckSendJIS)));
	witalk2_ptr->sendJIS = (Button_GetCheck(Hwnd(rCheckSendJIS))) ? true : false;

	// dN}ݒ
	// WXg֏
	lgRegistry reg( REGISTRY_ROOT );
	reg.Write("MultiProcess", Button_GetCheck(Hwnd(rCheckInhibitDupProcess)));

    SendMessage(HwndPropertySheetOwner(), WM_DIALOGNOTIFY, rDialogOther, TRUE);
    return lgDialog::wmNotify_psnApply();
  }
  
  // WM_COMMAND
  BOOL wmCommand(int notify_code, int id, HWND /* hwnd_control */)
  {
    switch (id)
    {
#define c(x) case r##x: return wmCommand_##x(notify_code)
      c(EditQuotationMark);
      
      c(CheckDoesSaveLog);
      c(CheckLogSavePrivateOnly);
      c(ButtonLogSaveFolderBrowse);
      c(EditLogSaveFolder);
	  c(NonStopAutoScrollInBacklog);
	  c(CheckBacklogSplit);
	  c(CheckSendJIS);
	  c(EditINISaveFolder);
	  c(ButtonINISaveFolderBrowse);
#undef c
    }
    return TRUE;
  }

  // INI ۑfBNg
  BOOL wmCommand_EditINISaveFolder(int command)
  {
	  if (command == EN_UPDATE) PropertySheetChanged();
	  return TRUE;
  }

  // obNÕI[gXN[
  BOOL wmCommand_NonStopAutoScrollInBacklog(int command)
  {
	  PropertySheetChanged(); set_all(); return TRUE;
  }

  // obNOEBhEʕ\
  BOOL wmCommand_CheckBacklogSplit(int command)
  {
	  PropertySheetChanged(); set_all(); return TRUE;
  }

  // JIS ϊM
  BOOL wmCommand_CheckSendJIS(int command)
  {
	  PropertySheetChanged(); set_all(); return TRUE;
  }
  
  // p
  BOOL wmCommand_EditQuotationMark(int command)
  {
    if (command == EN_UPDATE)
      PropertySheetChanged();
    return TRUE;
  }
  
  // O
  BOOL wmCommand_CheckDoesSaveLog(int command)
  {
    PropertySheetChanged();
    set_all();
    return TRUE;
  }
  
  // dƗ`̂݃Z[u
  BOOL wmCommand_CheckLogSavePrivateOnly(int command)
  {
    PropertySheetChanged();
    return TRUE;
  }
  
  // OtH_Q
  BOOL wmCommand_ButtonLogSaveFolderBrowse(int command)
  {
    if (command == BN_CLICKED)
    {
      char buf[BUFSIZE];
      GetWindowText(rEditLogSaveFolder, buf, sizeof(buf));
      if (lgFiles::OpenFolder(Hwnd(),
			      LoadString(rStringBrowseOpenLogSaveFolder),
			      buf, sizeof(buf)))
      {
	SetWindowText(rEditLogSaveFolder, buf);
	PropertySheetChanged();
      }
    }
    return TRUE;
  }

  // INI t@CۑtH_Q
  BOOL wmCommand_ButtonINISaveFolderBrowse(int command)
  {
	  if (command == BN_CLICKED){
		  char	buf[BUFSIZE];
		  GetWindowText(rEditINISaveFolder, buf, sizeof(buf));
		  if (lgFiles::OpenFolder(Hwnd(), LoadString(rStringBrowseINISaveFolder), buf, sizeof(buf))){
			  SetWindowText(rEditINISaveFolder, buf);
			  PropertySheetChanged();
		  }
	  }
	  return TRUE;
  }
  
  // OtH_
  BOOL wmCommand_EditLogSaveFolder(int command)
  {
    if (command == EN_UPDATE)
      PropertySheetChanged();
    return TRUE;
  }
};


BOOL CALLBACK DialogOtherDlgProc(HWND hwnd, UINT message,
				 WPARAM wParam, LPARAM lParam)
{
#define lgWindowClass DialogOther
  if (!lgwc)
    switch (message)
    {
      lgwmInitDialog;
    }
  else
    switch (message)
    {
      lgwmCommand;
    }
  return lgwc->Default(message, wParam, lParam, TRUE);
}
