/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// DialogWindows2000.cpp


#include	<winsock2.h>
#include	<crtdbg.h>
#include	<windows.h>

#include	<stdio.h>
#include	<stdlib.h>

#include	<shlobj.h>

#include	"WItalk2.h"
#include	"lgDialog.h"
#include	"rWItalk2.h"
#include	"resource.h"
#include	"commctrl.h"
#include    "ProfileManager.h"
#include	"WinDLL.h"
#include	"TrapFocus.h"

extern	int window_transparency;
extern	bool does_window_transparent, does_users_window_transparent, does_telegram_window_transparent;
extern	HWND		firstWindow, usersWindow;


void*	dialogwindows2000;

// ʌʐݒ_CAONX =======================================
//
class DialogWindows2000 : public lgDialog
{
	ProfileManager* m_pProfileManager;
	int		enableSemiTransparent;				// \s
	int		enableUsersSemiTransparent;			//
	int		enableTelegramSemiTransparent;		//
	int		windowTransparency;					// x
	int		enableLinegap;						// sԎws
	int		richeditLinegap;					// sԎw
	int		viewIconOnTasktray;					// ^XNgCɃACR\邩
	int		swallowWindow;						// ŏɃ^XNgCɎ[

	BOOL enable_update;

	void adjustButtonStatus()
	{
		// Windows2000 łȂΔ\I𖳌ɂ
		if (windows_ver < 0x0500){
			enableSemiTransparent = false; enableUsersSemiTransparent = false;
			enableTelegramSemiTransparent = false;
		}
		{
			Button_SetCheck(Hwnd(rCheckTransparent), enableSemiTransparent);
			Button_SetCheck(Hwnd(rCheckUsersTransparent), enableUsersSemiTransparent);
			Button_SetCheck(Hwnd(rCheckTelegramTransparent), enableTelegramSemiTransparent);
			int		enablesemitransparent = enableSemiTransparent | enableUsersSemiTransparent | enableTelegramSemiTransparent;
			EnableWindow(Hwnd(rSlideTransparency), enablesemitransparent);
			EnableWindow(Hwnd(rStaticTransparency), enablesemitransparent);
		}
		{
			Button_SetCheck(Hwnd(rCheckLinegap), enableLinegap);
			EnableWindow(Hwnd(rEditLinegap), enableLinegap); EnableWindow(Hwnd(rStaticLinegap), enableLinegap);
		}
		{
			char	linegap[BUFSIZE];
			sprintf(linegap, "%u", richeditLinegap);
			SetWindowText(Hwnd(rEditLinegap), linegap);
		}
		// Windows NT4 łȂ΃^XNgCnݒLɂ
		if (windows_ver < 0x0500 && IsNT()) viewIconOnTasktray = false, swallowWindow = false;
		{
			Button_SetCheck(Hwnd(rCheckTasktray), viewIconOnTasktray);
			EnableWindow(Hwnd(rCheckTasktrayMinimize), viewIconOnTasktray);
			Button_SetCheck(Hwnd(rCheckTasktrayMinimize), swallowWindow);
		}
	}

	void set_all(void)
	{
		//lgRegistry	reg(REGISTRY_ROOT);

		m_pProfileManager->Read("EnableMainSemiTransparent", enableSemiTransparent, false);
		m_pProfileManager->Read("EnableUsersSemiTransparent", enableUsersSemiTransparent, false);
		m_pProfileManager->Read("EnableTelegramSemiTransparent", enableTelegramSemiTransparent, false);
		m_pProfileManager->Read("WindowMainTransparency", windowTransparency, 192);
		windowTransparency = 255 - windowTransparency;

		Button_SetCheck(Hwnd(rCheckTransparent), enableSemiTransparent);
		Button_SetCheck(Hwnd(rCheckUsersTransparent), enableUsersSemiTransparent);
		Button_SetCheck(Hwnd(rCheckTelegramTransparent), enableTelegramSemiTransparent);
		SendMessage(Hwnd(rSlideTransparency), TBM_SETRANGE, (WPARAM)TRUE, (LPARAM)MAKELONG(0, 255-32));	// SɓɂȂĂ܂̂ƍ
		SendMessage(Hwnd(rSlideTransparency), TBM_SETPOS, (WPARAM)TRUE, (LPARAM)windowTransparency);

		m_pProfileManager->Read("EnableLinegap", enableLinegap, false);
		m_pProfileManager->Read("RichEditLinegap", richeditLinegap, 240);

		m_pProfileManager->Read("TasktrayIcon", viewIconOnTasktray, false);
		m_pProfileManager->Read("TasktrayStore", swallowWindow, false);

		adjustButtonStatus();
	}

	void reLinegap()
	{
		// EBhE ItalkView ɑ΂čsԐݒ
		witalk2_ptr->iv_input->SetLinegap();
		witalk2_ptr->iv_log_public->SetLinegap();
		// ʓdEBhEɑ΂čsԐݒ
		for (int i = 0; i < witalk2_ptr->telegramDeliveryMembers; i++) SendMessage(witalk2_ptr->telegramDeliveryTableHwnd[i], WM_COMMAND, (WPARAM)rPeerWindowLinegap, 0);
	}

	void reTransparent()
	{
		if (windll._SetLayeredWindowAttributes){
			// EBhE̍łẽEBhEɓEs
			if (does_window_transparent){
				SetWindowLong(firstWindow, GWL_EXSTYLE, GetWindowLongPtr(firstWindow, GWL_EXSTYLE) | WS_EX_LAYERED);
				windll._SetLayeredWindowAttributes(firstWindow, 0, window_transparency, LWA_ALPHA);
			} else {
				windll._SetLayeredWindowAttributes(firstWindow, 0, 255, LWA_ALPHA);
				SetWindowLong(firstWindow, GWL_EXSTYLE, GetWindowLongPtr(firstWindow, GWL_EXSTYLE) & ~WS_EX_LAYERED);
			}
			// Users EBhEɓEs
			if (does_users_window_transparent){
				SetWindowLong(usersWindow, GWL_EXSTYLE, GetWindowLongPtr(usersWindow, GWL_EXSTYLE) | WS_EX_LAYERED);
				windll._SetLayeredWindowAttributes(usersWindow, 0, window_transparency, LWA_ALPHA);
			} else {
				windll._SetLayeredWindowAttributes(usersWindow, 0, 255, LWA_ALPHA);
				SetWindowLong(usersWindow, GWL_EXSTYLE, GetWindowLongPtr(usersWindow, GWL_EXSTYLE) & ~WS_EX_LAYERED);
			}
			// ʓdEBhEɓEs
			if (does_telegram_window_transparent){
				for (int i = 0; i < witalk2_ptr->telegramDeliveryMembers; i++){
					SetWindowLong(witalk2_ptr->telegramDeliveryTableHwnd[i], GWL_EXSTYLE, GetWindowLongPtr(witalk2_ptr->telegramDeliveryTableHwnd[i], GWL_EXSTYLE) | WS_EX_LAYERED);
					windll._SetLayeredWindowAttributes(witalk2_ptr->telegramDeliveryTableHwnd[i], 0, window_transparency, LWA_ALPHA);
				}
			} else {
				for (int i = 0; i < witalk2_ptr->telegramDeliveryMembers; i++){
					windll._SetLayeredWindowAttributes(witalk2_ptr->telegramDeliveryTableHwnd[i], 0, 255, LWA_ALPHA);
					SetWindowLong(witalk2_ptr->telegramDeliveryTableHwnd[i], GWL_EXSTYLE, GetWindowLongPtr(witalk2_ptr->telegramDeliveryTableHwnd[i], GWL_EXSTYLE) & ~WS_EX_LAYERED);
				}
			}
		}
	}

public:
	DialogWindows2000(HWND _hwnd) : lgDialog(_hwnd), enable_update(FALSE){ }
  
	// WM_INITDIALOG
	BOOL wmInitDialog(HWND focus, LPARAM lParam)
	{
		if( lParam ){
			PROPSHEETPAGE* pProp = (PROPSHEETPAGE*)lParam;
			m_pProfileManager = (ProfileManager*)pProp->lParam;
		}
		_ASSERT( m_pProfileManager != NULL );

		dialogwindows2000 = (void*)this;
		set_all();
		;
		return TRUE;
	}

	// WM_COMMAND
	BOOL wmCommand(int notify_code, int id, HWND /* hwnd_control */)
	{
		switch(id){
		case rCheckTransparent:			PropertySheetChanged(); enable_update = true; enableSemiTransparent ^= true; adjustButtonStatus(); return true;
		case rCheckUsersTransparent:	PropertySheetChanged(); enable_update = true; enableUsersSemiTransparent ^= true; adjustButtonStatus(); return true;
		case rCheckTelegramTransparent:	PropertySheetChanged(); enable_update = true; enableTelegramSemiTransparent ^= true; adjustButtonStatus(); return true;
		case rSlideTransparency:		PropertySheetChanged(); enable_update = true; return true;
		case rCheckLinegap:				PropertySheetChanged(); enable_update = true; enableLinegap ^= true; adjustButtonStatus(); return true;
		case rCheckTasktray:			PropertySheetChanged(); enable_update = true; viewIconOnTasktray ^= true; adjustButtonStatus(); return true;
		case rCheckTasktrayMinimize:	PropertySheetChanged(); enable_update = true; swallowWindow ^= true; adjustButtonStatus(); return true;
		case rEditLinegap:				if (notify_code == EN_UPDATE){ PropertySheetChanged(); enable_update = true; return true; } else break;
		case IDCANCEL: return wmClose();
		}
		return TRUE;
  }

	void wmApply()
	{
		enableSemiTransparent = Button_GetCheck(Hwnd(rCheckTransparent));
		enableUsersSemiTransparent = Button_GetCheck(Hwnd(rCheckUsersTransparent));
		enableTelegramSemiTransparent = Button_GetCheck(Hwnd(rCheckTelegramTransparent));
		windowTransparency = SendMessage(Hwnd(rSlideTransparency), TBM_GETPOS, 0, 0);
		windowTransparency = 255 - windowTransparency;
		viewIconOnTasktray = Button_GetCheck(Hwnd(rCheckTasktray));
		swallowWindow = Button_GetCheck(Hwnd(rCheckTasktrayMinimize));
		char	linegap[1024];
		GetWindowText(Hwnd(rEditLinegap), linegap, sizeof(linegap));
		int		_richeditLinegap;
		sscanf(linegap, "%u", &_richeditLinegap);
		if (_richeditLinegap == 0){
			MessageBox(0, LoadString(rStringErrorInvalidLinegap), lgWindows::TheName(), MB_OK); richeditLinegap = 240;
		} else {
			richeditLinegap = _richeditLinegap;
		}
		{
			//lgRegistry	reg(REGISTRY_ROOT);
			// WXgɋL^
			m_pProfileManager->Write("EnableMainSemiTransparent", enableSemiTransparent);
			m_pProfileManager->Write("WindowMainTransparency", windowTransparency);
			m_pProfileManager->Write("EnableUsersSemiTransparent", enableUsersSemiTransparent);
			m_pProfileManager->Write("EnableTelegramSemiTransparent", enableTelegramSemiTransparent);
			m_pProfileManager->Write("EnableLinegap", enableLinegap);
			m_pProfileManager->Write("RichEditLinegap", richeditLinegap);
			m_pProfileManager->Write("TasktrayIcon", viewIconOnTasktray);
			m_pProfileManager->Write("TasktrayStore", swallowWindow);
			// ϐɔf
			window_transparency = windowTransparency; does_window_transparent = (enableSemiTransparent) ? true : false;
			does_users_window_transparent = (enableUsersSemiTransparent) ? true : false;
			does_telegram_window_transparent = (enableTelegramSemiTransparent) ? true : false;
			witalk2_ptr->tasktrayIcon = (viewIconOnTasktray) ? true : false;
			witalk2_ptr->tasktrayStore = (swallowWindow) ? true : false;
			// ʂɔf
			reTransparent();
			reLinegap();
			if (viewIconOnTasktray) witalk2_ptr->registerIconOnTasktray(); else witalk2_ptr->unregisterIconFromTasktray();
		}

	}

	// 
	BOOL wmClose(void)
	{
		EndDialog(Hwnd(), NULL);
		return TRUE;
	}
};

// ʌʐݒ_CAÕ_CAOvV[W =================
//
BOOL CALLBACK DialogWindows2000DlgProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
#define lgWindowClass DialogWindows2000
  if (!lgwc)
    switch (message)
    {
      lgwmInitDialog;
    }
  else
    switch (message)
    {
      lgwmCommand;
      lgwmClose;
    }
  if (message == WM_NOTIFY){
	  LPNMHDR	pnmh = (LPNMHDR)lParam;
	  switch(pnmh->code){
	  case NM_RELEASEDCAPTURE:
		  ((DialogWindows2000*)dialogwindows2000)->PropertySheetChanged(); break;
	  case PSN_APPLY:
		  {
			  DialogWindows2000*	dt = (DialogWindows2000*)dialogwindows2000;
			  dt->wmApply();
		  }
	  }
  }
  return lgwc->Default(message, wParam, lParam);
}
