/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// ProfileManager.h

#pragma once

#include <string>
#include <map>

class ProfileManager
{
protected:
	BOOL m_bProfileLoaded;
	std::map<std::string,std::string> m_Profile;
	std::string m_strProfileFileName;
public:
	ProfileManager(void);
	virtual ~ProfileManager(void);

	// isProfileLoadedTRUEł󕶎̏ꍇ
	// ( newProfileĂsaveProfileAsĂ΂܂ł̊ )
	std::string getProfileFileName() const { return m_strProfileFileName; }

	// create new profile
	// WXgǂݍ
	BOOL newProfile();
	// load profile from file
	BOOL loadProfile( const char* filename );
	// save profile to file
	BOOL saveProfileAs( const char* filename );

	BOOL isProfileLoaded() const { return m_bProfileLoaded; }

	//Read and Write functions
	BOOL Delete(const char * const name);
	// DWORD ǂ
	BOOL Read(const char * const name, int &buf, int default_value = 0);

	// DWORD 
	BOOL Write(const char * const name, int value);
	

	// ǂ
	BOOL Read(const char * const name, char *buf, const DWORD sizeof_buf,
		const char *default_str = NULL);
	

	// 
	BOOL Write(const char * const name, const char * const value);
	

	// Chǂ
	BOOL Read(const char * const name, wchar_t *buf, const DWORD sizeof_buf,
		const wchar_t *default_str = NULL);
	

	// Ch
	BOOL Write(const char * const name, const wchar_t * const value);

	// oCiǂ
	BOOL Read(const char * const name, BYTE *buf, DWORD &sizeof_buf,
		const BYTE *default_binary = NULL, DWORD sizeof_default_binary = 0);

	// oCi
	BOOL Write(const char * const name, const BYTE * const value,
			DWORD sizeof_value);

	// LOGFONT ǂ
	BOOL Read(const char * const name, LOGFONT &lf,
		const char * const default_string_logfont = NULL);

	// LOGFONT 
	BOOL Write(const char * const name, const LOGFONT &lf);

	// RECT ǂ
	BOOL Read(const char * const name, RECT &rc, const RECT &default_rc);

	// RECT 
	BOOL Write(const char * const name, const RECT &rc);
protected:
	BOOL profile_Write( const char* name, int value );
	BOOL profile_Write( const char* name, const char* value );
};
