/*
 * TrapFocus - RichEdit TuNX
 * Copyright (c) 2002 by Project Waffle / TSUJIKAWA Tohru <tsujikawa@tsg.ne.jp>
 *  
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// TrapFocus.cpp


#include	<winsock2.h>
#include	<windows.h>
#include	<stdio.h>
#include	"WItalk2.h"
#include	"TrapFocus.h"


int		windows_ver = 0x0400;						// Windows version


//
// tH[JXԊǗ
//

WindowFocusStatus::WindowFocusStatus()
{
	currentFocused = NULL;
}

WindowFocusStatus::~WindowFocusStatus()
{
}

void WindowFocusStatus::setFocus(HWND hwnd)
{
	AutoMutex	amutex(&mutex);
	map<HWND, bool>::iterator p = focusmap.find(hwnd);
	if (p == focusmap.end()) {
		focusmap.insert(pair<HWND, bool>(hwnd, true));
	} else {
		p->second = true;
	}
	currentFocused = hwnd;
}

void WindowFocusStatus::killFocus(HWND hwnd)
{
	AutoMutex	amutex(&mutex);
	map<HWND, bool>::iterator p = focusmap.find(hwnd);
	if (p == focusmap.end()) {
		focusmap.insert(pair<HWND, bool>(hwnd, false));
	} else {
		p->second = false;
	}
	if (currentFocused == hwnd) currentFocused = NULL;
}

bool WindowFocusStatus::isFocused(HWND hwnd)
{
	AutoMutex	amutex(&mutex);
	map<HWND, bool>::iterator p = focusmap.find(hwnd);
	if (p == focusmap.end()) return false; else return p->second;
}

WindowFocusStatus	wfocusStatus;


//
// ReLXgj[o
//
static void popupRButtonMenu(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	POINT	point;
	point.x = LOWORD(lParam), point.y = HIWORD(lParam); ClientToScreen(hwnd, &point);
	HMENU&	hPopupMenu = witalk2_ptr->hPopupMenu;

	// ÕI[gXN[̃`FbN
	CheckMenuItem(hPopupMenu, rCommandLogAutoScroll, ((witalk2_ptr->isCheckedAutoScroll) ? (MF_CHECKED) : (0)) | MF_BYCOMMAND);

	// [UꗗEBhẼ`FbN
	CheckMenuItem(hPopupMenu, rCommandOtherUsers, (witalk2_ptr->menu.IsChecked(rCommandOtherUsers) ? MF_CHECKED : 0) | MF_BYCOMMAND);

	// I[gXN[ƃ[UꗗEBhẼj[L
	EnableMenuItem(hPopupMenu, rCommandLogAutoScroll, MF_ENABLED | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandOtherUsers, MF_ENABLED | MF_BYCOMMAND);

	EnableMenuItem(hPopupMenu, rCommandClearBuffer, MF_ENABLED | MF_BYCOMMAND);

	bool	bufselected = !!witalk2_ptr->iv_get_focused()->Re.IsSelected();
	EnableMenuItem(hPopupMenu, rCommandEditCopy, (bufselected ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	bool	bufwritable = !witalk2_ptr->iv_get_focused()->Re.GetReadOnly();
	EnableMenuItem(hPopupMenu, rCommandEditCut, ((bufselected & bufwritable) ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	bool	selsend = bufselected && witalk2_ptr->isConnectionActive;
	EnableMenuItem(hPopupMenu, rCommandEditSendToItalk, (selsend ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	// Nbv{[hɃeLXg΃y[XgnON
	bool	clipext = IsClipboardFormatAvailable(CF_TEXT) || IsClipboardFormatAvailable(CF_OEMTEXT) || IsClipboardFormatAvailable(CF_UNICODETEXT);
	EnableMenuItem(hPopupMenu, rCommandEditQuotedPaste, (clipext ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandEditPaste, (clipext ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	// ڑłȂ΃y[XgMnOFF
	bool	clipsend = clipext && witalk2_ptr->isConnectionActive;
	EnableMenuItem(hPopupMenu, rCommandEditPasteSendToItalk, (clipsend ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandEditQuotedPasteSendToItalk, (clipsend ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	// ReLXgj[\
	SetForegroundWindow(hwnd);
	TrackPopupMenu(hPopupMenu, 0, point.x, point.y, 0, witalk2_ptr->Hwnd(), NULL);
	PostMessage(hwnd, WM_NULL, 0, 0);
}


//
// TuNX RichEdit EBhEvV[W (̓obt@p)
//
LRESULT CALLBACK RichEditSubclassInput(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	POINT		caretPos;
	ReSubClass*	data = (ReSubClass*)GetWindowLongPtr(hwnd, GWLP_USERDATA);

	_ASSERT(data);

	switch (iMsg) {
	case WM_KEYDOWN:	// ReLXgj[\
		if (wParam != 0x5D || lParam != 0x15D0001) break;
		if (GetCaretPos(&caretPos) == 0) break;
		lParam = MAKELONG(caretPos.y, caretPos.x);
	case WM_RBUTTONDOWN:
		popupRButtonMenu(hwnd, wParam, lParam);
		return 0;
	case WM_SETFOCUS:
		if (lParam != ReSubClass::focusMagicNo) wfocusStatus.setFocus(hwnd);
		break;
	case WM_KILLFOCUS:
		if (lParam != ReSubClass::focusMagicNo) wfocusStatus.killFocus(hwnd);
		break;
	}
	return CallWindowProc(data->oldWndProc, hwnd, iMsg, wParam, lParam);
}


//
// TuNX RichEdit EBhEvV[W (OEBhEp)
//
LRESULT CALLBACK RichEditSubclassLog(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	POINT	caretPos;
	ReSubClass*	data = (ReSubClass*)GetWindowLongPtr(hwnd, GWLP_USERDATA);

	_ASSERT(data);

	switch(iMsg){
	case WM_RBUTTONDOWN:
rbutton:
		popupRButtonMenu(hwnd, wParam, lParam);
		return 0;
	case WM_SETFOCUS:
		data->blockMessage = 0;
		if (lParam == ReSubClass::focusMagicNo){
			lParam = 0; data->blockMessage = false;
		} else {
			AQT(("RichEdit SETFOCUS %.8X\n", hwnd));
			wfocusStatus.setFocus(hwnd);
		}
		break;
	case WM_KILLFOCUS:
		data->blockMessage = 0;
		if (lParam == ReSubClass::focusMagicNo){
			lParam = 0; data->blockMessage = true; data->canSkipMessages = 4096;
		} else {
			AQT(("RichEdit KILLFOCUS %.8X\n", hwnd));
			wfocusStatus.killFocus(hwnd);
		}
		break;
	// O̒ǉ̓L[{[hCxgx
	case WM_KEYDOWN: case WM_KEYUP: case WM_CHAR: 
		data->canSkipMessages--;
		if (data->blockMessage && data->canSkipMessages > 0){
			PostMessage(hwnd, iMsg, wParam, lParam); return 0;
		}
		// ReLXgj[
		if (iMsg == WM_KEYDOWN){
			if (wParam != 0x5D || lParam != 0x15D0001) break;;
			if (GetCaretPos(&caretPos) == 0) break;
			lParam = MAKELONG(caretPos.y, caretPos.x);
			goto rbutton;
		}
	}
	
	return CallWindowProc(data->oldWndProc, hwnd, iMsg, wParam, lParam);
}
