/*
 * TrapFocus - RichEdit TuNX
 * Copyright (c) 2002 by Project Waffle / TSUJIKAWA Tohru <tsujikawa@tsg.ne.jp>
 *  
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// TrapFocus.h


#pragma	once


#include	<map>
using namespace std;

#include	"SimpleMutex.h"


extern		int	windows_ver;

//
// RichEdit TuNX[`pf[^̈
//
class ReSubClass {

public:

	static const LPARAM focusMagicNo = 0x4624;		// WM_SETFOCUS/WM_KILLFOCUS Up Magic No.

	WNDPROC	oldWndProc;								// EBhEvV[W
	bool	inputMode;								// ̓obt@[h

	bool	blockMessage;							// L[{[hCxg񑗃[h
	int		canSkipMessages;						// ő񑗉

	ReSubClass() { oldWndProc = NULL; blockMessage = false; canSkipMessages = 0; inputMode = false; }
	~ReSubClass() {}

};

//
// tH[JXԊǗ
//
class WindowFocusStatus {

	map<HWND, bool>		focusmap;
	SimpleMutex			mutex;
	HWND				currentFocused;

public:

	WindowFocusStatus();
	~WindowFocusStatus();

	void setFocus(HWND hwnd);
	void killFocus(HWND hwnd);

	bool isFocused(HWND hwnd);
	HWND getFocused() { return currentFocused; }

};

extern		WindowFocusStatus wfocusStatus;


extern		LRESULT CALLBACK RichEditSubclassInput(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);
extern		LRESULT CALLBACK RichEditSubclassLog(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);
