// Italk Protocol 1.0 and biff-port support modifications.
// Copyright (C) 1998, SAKAMOTO Takahiro <takas@is.s.u-tokyo.ac.jp>

/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// WItalk2ItalkView.h

#include	<winsock2.h>
#include <tchar.h>

#include "WItalk2.h"
#include "DialogParanoia1.h"

#include "TrapFocus.h"

#undef	set_key

extern bool	sent_handle;			// Waffle 0.1.11

//  (splitbar  toolbar  statusbar ̌ɌĂ΂)
void WItalk2::iv_create(void)
{
	iv_input	 = new ItalkView(hwnd_splitbar,this, &foColorInput, &bkColorInput, ES_AUTOVSCROLL);
	iv_log_public  = new ItalkView(hwnd_splitbar,this, &foColorInput, &bkColorLogPublic, ES_AUTOVSCROLL | ES_READONLY);
#ifdef USE_EMACS_KEYBIND
	if (menu.IsChecked(rCommandOtherEmacsKeyBinding)) {
		iv_input	->Re.EnableEmacsBinding(statusbar);
		iv_log_public ->Re.EnableEmacsBinding(statusbar);
		iv_set_keybinding(iv_input);
		iv_set_keybinding(iv_log_public);
	}
#endif
	iv_input->setParentPointer(this);
	iv_log_public->setParentPointer(this);
	// TuNX
	iv_input->setSubclass(true);
	iv_log_public->setSubclass(false);

	hwnd_tooltip	= toolbar->GetTooltips();
}


// Ƃ܂
void WItalk2::iv_destroy(void)
{
	delete iv_input;
	delete iv_log_public;
	iv_input = NULL;
	iv_log_public = NULL;
}


#if USE_EMACS_KEYBIND
// L[oCfBO̐ݒ
void WItalk2::iv_set_keybinding(ItalkView *iv)
{
  lgKeyBindingsMap *keymap = iv->Re.GetKeyBindingsMap('C');
  const int ctrl = lgKeyBindingsMap::Ctrl;
  const int parent = lgKeyBindingsMap::DestParent;
#define set_key(c,command)					\
  keymap->SetChar(c + 0x20, 0	, parent, WM_COMMAND, command); \
  keymap->SetChar(c	  , 0	, parent, WM_COMMAND, command); \
  keymap->SetChar(c	  , ctrl, parent, WM_COMMAND, command);
  if (keymap)
  {
    set_key('K', rCommandLogEnableKillName);
    set_key('P', rCommandKeyTab);
    set_key('R', rCommandEditSendToItalk);
    set_key('S', rCommandLogAutoScroll);
    set_key('V', rCommandHelpAbout);
    set_key('Q', rCommandConnectionDisconnect);
    set_key('?', rCommandHelpAbout);
    keymap->SetChar(' '  , 0   , parent, WM_COMMAND, rCommandKeyMNext);
    keymap->SetChar('\7f', 0   , parent, WM_COMMAND, rCommandKeyMPrior);
    keymap->SetChar('H'  , ctrl, parent, WM_COMMAND, rCommandKeyMPrior);
  }
  keymap = iv->Re.GetKeyBindingsMap('X');
  if (keymap)
  {
    set_key('O', rCommandKeyCF6);
  }
}
#endif


// tH[JX̂ ItalkView Ԃ (Ȃ NULL)
ItalkView *WItalk2::iv_get_focused_only(void)
{
  HWND fhwnd = GetFocus();
  if (fhwnd == iv_input      ->Re.Hwnd()) return iv_input;
  if (fhwnd == iv_log_public ->Re.Hwnd()) return iv_log_public;
  return NULL;
}


// tH[JX̂ ItalkView Ԃ (Ȃ iv_input)
ItalkView *WItalk2::iv_get_focused(void)
{
  ItalkView *iv = iv_get_focused_only();
  return iv ? iv : iv_input;
}


// tHgƔwiF̐ݒ
void WItalk2::iv_set_font_and_bkcolor(BOOL does_set_font)
{
  iv_input	->ReadRegistry(does_set_font);
  iv_log_public ->ReadRegistry(does_set_font);
  // Waffle 0.2.0d: ʓdEBhẼtHgƔwiFĐݒ
  for (int i = 0; i < telegramDeliveryMembers; i++) SendMessage(telegramDeliveryTableHwnd[i], WM_COMMAND, rPeerWindowColorFont, does_set_font);
}


#ifdef	USE_EMACS_KEYBIND
// Emacs ̃L[oCfBOg悤ɂ
void WItalk2::iv_use_emacs_key_binding(BOOL f)
{
  lgcRichEdit::KeyBinding k =
    f ? lgcRichEdit::KeyBindingEmacs : lgcRichEdit::KeyBindingWindows;
  iv_input	->Re.SelectKeyBinding(k);
  iv_log_public ->Re.SelectKeyBinding(k);
  // Waffle 0.2.0d: ʓdEBhEɂf
  for (int i = 0; i < telegramDeliveryMembers; i++) SendMessage(telegramDeliveryTableHwnd[i], WM_COMMAND, rPeerWindowEmacsBinding, f);
}
#endif


// c[`bv
void WItalk2::set_tooltip(void)
{
  BOOL does_show_tip = DialogParanoia1::paranoia1_showtip;

  TOOLINFO ti;
  ti.cbSize   = sizeof(TOOLINFO);
  ti.uFlags   = TTF_IDISHWND | TTF_SUBCLASS;
  ti.hinst    = NULL;

  ti.hwnd     = iv_input->Re.Hwnd();
  ti.uId      = (UINT)ti.hwnd;
  ti.lpszText = does_show_tip ? LoadString(rStringTipInput) : "";
  SendMessage(hwnd_tooltip, TTM_ADDTOOL, 0, (LPARAM)&ti);

  ti.hwnd     = iv_log_public->Re.Hwnd();
  ti.uId      = (UINT)ti.hwnd;
  ti.lpszText = does_show_tip ? LoadString(rStringTipLogPublic) : "";
  SendMessage(hwnd_tooltip, TTM_ADDTOOL, 0, (LPARAM)&ti);
}


// 
void WItalk2::send_str(const wchar_t *str)
{
	ic.Write(str);
	if (DialogParanoia1::paranoia1_debugechoback) add_log(str);
}

void WItalk2::send_str(const char* str)
{
	ic.Write(str);
	if (DialogParanoia1::paranoia1_debugechoback) add_log(str);
}


// Jbĝs𑗂A̍sɃJbgڂ
BOOL WItalk2::iv_send_current_line(BOOL does_send_emply_line_too,
				   ItalkView *iv, BOOL does_insert_newline, BOOL telegramCast, int toUserno)
  // TRUE:  ݂̍s /p ł̂ŁA̍s /p łׂ
  // FALSE: ݂̍s /p ł͂Ȃ
{
  BOOL r = FALSE;
  if (!iv)
    iv = iv_input;
  int start_index = -1;
  int end_index = -1;

  wchar_t *line = iv->Re.newGetLineW(&start_index, &end_index);
  BOOL is_empty = wcsequal(line, L"\r\n");
  if (line)
  {
    if (!is_empty ||
	(is_empty && does_send_emply_line_too)) // s𑗂
      if (check_private_message(line, r))
		  if (sent_handle){
			  if (telegramCast){	// Waffle 0.2.0: d`ԑM
				  if (italk_info.server.is_inid && toUserno > 9990) {
					  wchar_t	telegramHead[BUFSIZE];
					  swprintf(telegramHead, L"%d:", 10000-toUserno);
					  send_str(telegramHead);
				  } else {
					  wchar_t	telegramHead[BUFSIZE];
					  swprintf(telegramHead, L"/p %d ", toUserno);
					  send_str(telegramHead);
				  }
			  }
			  send_str(line);		// Waffle 0.1.11: ڑmO̔j~
		  }
    delete_string(line);
  }
  // ̍sֈړ
  int line_index = iv->Re.LineFromChar(end_index);
  if (iv->Re.GetLineCount() - 1 == line_index)
  {
    iv->Re.MoveCaret(end_index);
    iv->Re.Insert(L"\r\n");
  }
  else
  {
    int char_index = iv->Re.CharFromLine(line_index + 1);
    iv->Re.MoveCaret(char_index);
    if (does_insert_newline)
    {
      iv->Re.Insert(L"\r\n");
      iv->Re.MoveCaret(char_index);
    }
  }
  iv->Re.SetModify(FALSE);
  iv->Re.EmptyUndoBuffer();
  return r;
}


// key down ꂽ
BOOL WItalk2::iv_key_down(void)
{
  if (GetFocus() == iv_input->Re.Hwnd())
  {
    int line_index = iv_input->Re.LineFromChar(iv_input->Re.GetCaretIndex());
    if (iv_input->Re.GetLineCount() - 1 == line_index)
    {
		if (!freeeditmode) {
			iv_input->Re.MoveCaretToTheLast();
			iv_input->Re.Insert(L"\r\n");
		}
		return TRUE;
    }
  }
  return FALSE;
}
