/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgDialog.h


#pragma	once


#include "lgWindows.h"

#include "lgcSpin.h"
#include "lgcButton.h"


class lgDialog : public lgMainWindow
{
public:
  lgDialog(HWND _hwnd)
    : lgMainWindow(_hwnd)
  {
    default_return_value = TRUE;
  }
  
  virtual ~lgDialog() { }
  
  BOOL Default(UINT message, WPARAM wParam,
			 LPARAM lParam, BOOL is_property = FALSE);
  
  virtual BOOL wmNotify_psnReset(void)
  {
    return TRUE;
  }
  
  virtual BOOL wmNotify_psnKillActive(void)
  {
    SetWindowLong(Hwnd(), DWL_MSGRESULT, FALSE);
    return TRUE;
  }
  
  virtual BOOL wmNotify_psnApply(void)
  {
    SetWindowLong(Hwnd(), DWL_MSGRESULT, PSNRET_NOERROR);
    return TRUE;
  }
  
  // Misc
  
  BOOL Radio_Check(int id, int from, int to)
  {
    return CheckRadioButton(Hwnd(), from, to, id);
  }
  
  void PropertySheetChanged(void)
  {
    PropSheet_Changed(GetParent(Hwnd()), Hwnd());
  }
  
  HWND HwndPropertySheetOwner(void)
  {
    return GetParent(GetParent(Hwnd()));
  }
  
public:
  // Edit Rg[ NT3.51 Ȃ Static Rg[ɒu
  static HWND EditOrStatic(HWND hwnd_edit);
};
