/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgFiles.cxx

#include	<winsock2.h>
#include "lgFiles.h"
#include "lgRegistry.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <shlobj.h>
#include <direct.h>

#include <process.h>

#include "DialogURL.h"
#include "WinDLL.h"

// SFN  LFN 𓱂
HANDLE GetLongPathName(const char *sfn, char *lfn, int sizeof_lfn)
{
  WIN32_FIND_DATA fd;
  HANDLE hff = FindFirstFile(sfn, &fd);
  if (hff != INVALID_HANDLE_VALUE)
  {
    if ((size_t)sizeof_lfn <= strlen(lfn))
      return INVALID_HANDLE_VALUE;
    strcpy(lfn, sfn);
    lgFiles::GetPath(lfn);
    if ((size_t)sizeof_lfn <= strlen(lfn) + strlen(fd.cFileName))
      return INVALID_HANDLE_VALUE;
    strcat(lfn, fd.cFileName);
  }
  return hff;
}

	
// SFN  LFN 𓱂
// pX擾̂Ɏs lfn ɂ sfn Rs[
char *lgFiles::GetLongPathName(const char *sfn, char *lfn,
					 int sizeof_lfn,
					 BOOL does_consider_unc)
{
  int sizeof_sfn = strlen(sfn) + 1;
  char *sfn_buf = (char *)_alloca(sizeof_sfn);
  strcpy(sfn_buf, sfn);
  PackPath(sfn_buf, does_consider_unc);
  char *buf = (char *)_alloca(sizeof_sfn * 2);
  buf[0] = '\0';
  
  lfn[0] = '\0';
  char *s = sfn_buf;
  if (s[0] == '/'  || s[0] == '\\')
    if (s[1] == '/' || s[1] == '\\') // UNC
    {
      s = _mbspbrk(sfn_buf + 2, "/\\");
      if (!s)
      {
	strncpy(lfn, sfn_buf, sizeof_lfn);
	lfn[sizeof_lfn - 1] = '\0';
	return lfn;
      }
      s++;
      strncpy(buf, sfn_buf, s - sfn_buf);
      buf[s - sfn_buf] = '\0';
    }
    else // full path
    {
      buf[0] = *(s++);
      buf[1] = '\0';
    }
  
  while (1)
  {
    char *n = _mbspbrk(s, "/\\");
    if (n && s < n && n[-1] == ':')
      n = _mbspbrk(n + 1, "/\\");
    if (!n)
    {
      if (s[0])
      {
	strcat(buf, s);
	HANDLE hff = ::GetLongPathName(buf, lfn, sizeof_lfn);
	if (hff == INVALID_HANDLE_VALUE)
	{
	  strncpy(lfn, sfn, sizeof_lfn);
	  lfn[sizeof_lfn - 1] = '\0';
	  return NULL;
	}
	FindClose(hff);
      }
      else
	strcpy(lfn, sfn_buf);
      return lfn;
    }
    
    int len = strlen(buf);
    strncpy(buf + len, s, n - s);
    buf[len + n - s] = '\0';
    HANDLE hff = ::GetLongPathName(buf, lfn, sizeof_lfn);
    if (hff == INVALID_HANDLE_VALUE)
    {
      strncpy(lfn, sfn, sizeof_lfn);
      lfn[sizeof_lfn - 1] = '\0';
      return NULL;
    }
    FindClose(hff);
    strcpy(buf, lfn);
    
    char p[] = { *n, '\0' };
    strcat(buf, p);
    
    s = n + 1;
  }
}

	
// ChJ[h}b`O (UNIX V) 啶ʂȂ
// lgFiles::WildMatch("files.txt", "*.t??") Ȃ
BOOL lgFiles::WildMatch(const char *str1, const char *str2)
{
  int i_end_r;
  char *c_end_r;
  BOOL r = lgString::DoesMatch(str1, str2, i_end_r, c_end_r, FALSE);
  return r && (*c_end_r == '\0');
}


// D:\folders\file  file 菜
char *lgFiles::GetPath(char *buf)
{
  if (buf)
  {
    char *b = _mbsrchr(buf, '\\');
    char *s = _mbsrchr(buf, '/');
    char *c = _mbsrchr(buf, ':');
    char *p = max(max(b, s), c);
    if (p)
      p[1] = '\0';
    else
      buf[0] = '\0';
  }
  return lgFiles::PackPath(buf);
}


// D:\folders\file  file o
char *lgFiles::GetName(char *buf)
{
  if (buf)
  {
    char *b = _mbsrchr(buf, '\\');
    char *s = _mbsrchr(buf, '/');
    char *c = _mbsrchr(buf, ':');
    char *p = max(max(b, s), c);
    if (p) return p + 1;
  }
  return buf;
}


// D:\folders\filename\  D:\folders\filename ɂ
char *lgFiles::ToName(char *buf)
{
  if (buf)
  {
    int len = strlen(buf);
    while (0 < len)
      if (buf[len - 1] == '\\' ||
	  buf[len - 1] == '/')
	buf[--len] = '\0';
      else
	break;
  }
  return buf;
}


// D:\folders  D:\folders\ ɂ
char *lgFiles::ToPath(char *buf)
{
  if (buf)
  {
    lgFiles::ToName(buf);
    int len = strlen(buf);
    if (!(0 < len && buf[len - 1] == ':'))
      strcat(buf, "\\");
  }
  return buf;
}


// path ̘̒A \ 菜
char *lgFiles::PackPath(char *path, BOOL does_consider_unc)
{
  if (!path)
    return NULL;
  
  char *p = path;
  
  if (does_consider_unc)
  {
    char *f = _mbspbrk(path, ":/\\");
    if (f && *f == ':')
    {
      p = f + 1;
      if (path + 1 == f) // hCu
	does_consider_unc = FALSE;
      else // URL
	;
    }
  }
  
  if (does_consider_unc && (*p == '\\' || *p == '/'))
    p++;
  
  while (1)
  {
    for (;; p = _mbsinc(p))
      if      (!*p) return path;
      else if (*p == '\\' || *p == '/') break;
    p = _mbsinc(p);
    char *pp = p;
    for (;; pp = _mbsinc(pp))
      if (!(*pp == '\\' || *pp =='/')) break;
    strcpy(p, pp);
  }
}


// st@Cǂɂ邩ׂ
// (PATH ̒ ; ܂ނ̂Ƃ܂Ȃ)
// TODO : sizeof_buf
BOOL lgFiles::ResolvePath(const char *filename,
				    char *buf, int sizeof_buf)
{
  struct _stat sbuf;
  if (!_stat(filename, &sbuf))
    return TRUE;
  
  char path_buf[BUFSIZE];
  *path_buf = '\0';
  if (!GetEnvironmentVariable("PATH", path_buf, sizeof(path_buf)))
    return FALSE;
  char *path = _mbstok(path_buf, ";");
  while (path)
  {
    strcpy(buf, path);
    lgFiles::ToPath(buf);
    strcat(buf, filename);
    if (!_stat(buf, &sbuf))
      return TRUE;
    path = _mbstok(NULL, ";");
  }
  return FALSE;
}


// pX ITEMIDLIST ߂
static ITEMIDLIST *path_to_ITEMIDLIST(const char *path)
{
  IShellFolder *desktop;
  if (SUCCEEDED(SHGetDesktopFolder(&desktop)))
  {
    OLECHAR ole_path[MAX_PATH];
    MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, path, -1, ole_path, MAX_PATH);
    ITEMIDLIST *pidl;
    ULONG dummy;
    if (SUCCEEDED(desktop->ParseDisplayName(NULL, NULL, ole_path,
					    &dummy, &pidl, &dummy)))
    {
      desktop->Release();
      return pidl;
    }
    desktop->Release();
  }
  return NULL;
}


// ITEMIDLIST  Free
static void FreeITEMIDLIST(ITEMIDLIST *pidl)
{
  IMalloc *imalloc = NULL;
  if (SHGetMalloc(&imalloc) == NOERROR)
    imalloc->Free((void *)pidl);
}


// tH_J_CAOR[obN
static int CALLBACK browse_call_back_proc(HWND hwnd, UINT message,
					  LPARAM lParam, LPARAM lpData)
{
  if (message == BFFM_INITIALIZED)
  {
    /*
    char buf[BUFSIZE];
    if (GetCurrentDirectory(sizeof(buf), buf))
    {
      ITEMIDLIST *pidl = path_to_ITEMIDLIST(buf);
      SendMessage(hwnd, BFFM_SETSELECTION, FALSE, (LPARAM)pidl);
      FreeITEMIDLIST(pidl);
    }
    */
    ITEMIDLIST *pidl = path_to_ITEMIDLIST((char *)lpData);
    SendMessage(hwnd, BFFM_SETSELECTION, FALSE, (LPARAM)pidl);
    FreeITEMIDLIST(pidl);
  }
  return 0;
}


// tH_J_CAO\
BOOL lgFiles::OpenFolder(HWND hwnd_owner, const char *title,
				   char *folder, int sizeof_folder)
  // hwnd_owner    : OpenFolder _CAÕI[i[
  // title         : OpenFolder _CAÕ^Cg
  // folder        : tH_, IꂽtH_
  // sizeof_folder : folder ̃TCY
  // return        : TRUE   ... folder ɑIꂽtH_i[Ă
  //                 FALSE s
{
	if (sizeof_folder < MAX_PATH) return FALSE;

	BROWSEINFO bi;
	ZeroMemory(&bi, sizeof(bi));
	bi.hwndOwner      = hwnd_owner;
	bi.pidlRoot       = NULL;
	bi.pszDisplayName = folder;
	bi.lpszTitle      = title;
	bi.ulFlags        = BIF_RETURNONLYFSDIRS;
	bi.lpfn           = browse_call_back_proc;
	bi.lParam         = (LPARAM)folder;

	ITEMIDLIST *browse = SHBrowseForFolder(&bi);
	int r = FALSE;
	if (browse != NULL) {
		if (SHGetPathFromIDList(browse, folder)) {
			lgFiles::ToPath(folder);
			_chdir(folder);
			r = TRUE;
		}
		FreeITEMIDLIST(browse);
	}
	return r;
}


// R}hCst@Co
// commandline  buf ̗̈悪dȂĂĂ悢
BOOL lgFiles::CommandlineToCommand(const char *commandline,
					    char *buf, int sizeof_buf)
{
  if (!commandline || !buf || sizeof_buf < 1)
    return FALSE;
  const char *r;
  if (commandline[0] == '\"') // "  mule ŐF͂ݏoȂ悤ɂ邽
  {
    r = _mbschr(++commandline, '\"'); // "
    if (!r)
      return FALSE;
  }
  else
  {
    r = _mbschr(commandline, ' ');
    if (!r)
      r = commandline + strlen(commandline);
  }
  if (sizeof_buf <= r - commandline)
    return FALSE;
  MoveMemory(buf, commandline, r - commandline);
  buf[r - commandline] = '\0';
  return TRUE;
}


#include <ddeml.h>


static HDDEDATA CALLBACK DdeCallback(
  UINT uType, UINT uFmt, HCONV hconv, HSZ hsz1, HSZ hsz2,
  HDDEDATA hdata, DWORD dwData1, DWORD dwData2)
{
  return (HDDEDATA)NULL;
}


//
// vZXN
//
bool lgFiles::execProcess(const char* program, const char* param, DWORD pri, bool showErr)
{
	STARTUPINFO			xsi;
	PROCESS_INFORMATION	xpi;
	char	reParam[BUFSIZE];

	GetStartupInfo(&xsi);
	sprintf(reParam, "\x22%s\x22 %s", program, param);
	if (CreateProcess(program, reParam, NULL, NULL, FALSE, pri, NULL, NULL, &xsi, &xpi)) return true;
	if (showErr) {
		char	msgbuf[BUFSIZE];
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), LANG_SYSTEM_DEFAULT, msgbuf, sizeof(msgbuf), NULL);
		MessageBox(0, msgbuf, lgWindows::TheName(), MB_OK);
	}
	return false;
}

//
// vZXN
//
//   R}hC "%1" %1 ꍇ URL Œus
//
bool lgFiles::execProcess(const char* program, const char* param1, const char* param2, DWORD pri, bool showErr)
{
	string	p1(param1), p2(param2);
	int		i = 0;
	if ((i = p1.find("\x22%1\x22")) != p1.npos) {
		p1.replace(i, 4, p2); p2.clear();
	} else if ((i = p1.find("%1")) != p1.npos) {
		p1.replace(i, 2, p2); p2.clear();
	}
	return execProcess(program, p1.append(" ").append(p2).c_str(), pri, showErr);
}

// R}hCvOƈparse
void lgFiles::parseCmdline(const char* s, char* prog, char* param)
{
	size_t	slen = mbstowcs(NULL, s, 0);
	if (slen < 0) {
		if (prog) *prog = 0;
		if (param) *param = 0;
		return;
	}
	wchar_t*	ws = new wchar_t[slen+1];
	mbstowcs(ws, s, slen+1);
	int		argc;
	wchar_t** argv = CommandLineToArgvW(ws, &argc);
	if (prog) {
		size_t	clen = wcstombs(NULL, argv[0], 0);
		if (clen < 0) {
			*prog = 0;
		} else {
			char*	cs = new char[clen+1];
			wcstombs(cs, argv[0], clen+1); strcpy(prog, cs);
			delete [] cs;
		}
	}
	if (param) {
		*param = 0;
		for (int i = 1; i < argc; i++) {
			size_t	clen = wcstombs(NULL, argv[i], 0);
			if (clen < 0) continue;
			char*	cs = new char[clen+1];
			wcstombs(cs, argv[i], clen+1);
			if (strchr(cs, 0x20)) {
				strcat(param, "\x22"); strcat(param, cs); strcat(param, "\x22");
			} else {
				strcat(param, cs);
			}
			delete [] cs;
			if (i < argc-1) strcat(param, " ");
		}
	}
	LocalFree(argv);
	delete [] ws;
	return;
}

// URL J (݂ .html ̂ݑΉ)
BOOL lgFiles::OpenURL(const char *url, int openmode)
{
	_ASSERT(url);
	// UNCꍇ explorer N
	if (url[0] == 0x5C && url[1] == 0x5C) {
		char		explorer[BUFSIZE];
		GetWindowsDirectory(explorer, sizeof(explorer)); strcat(explorer, "\\explorer.exe");
		return execProcess(explorer, url);
	}
	// "ttp://" ꍇ "http://" ɒu
	if (url && _strnicmp(url, "ttp://", 6) == 0) {
		char* _url = (char*)_alloca(strlen(url)+2);
		strcpy(_url, string("h").append(url).c_str());
		url = _url;
	}
#if 0
	// vgRo
	char *p = _mbschr(url, ':');
	if (!p) return FALSE;
	char protocol[BUFSIZE];
	strncpy(protocol, url, p - url);
	protocol[p - url] = '\0';
#else
	// Waffle 0.2.4: ɃvgR http:// ̊֘AÂvOɓn
	const char* protocol = "http";
#endif
	// uEŨR}hC擾
	char buf[BUFSIZE];
	BOOL can_shell_exec = TRUE;
	if (!lgRegistry::GetAssociatedCommandline(protocol, buf, sizeof(buf))) {
		can_shell_exec = FALSE;
		if (!lgRegistry::GetAssociatedCommandline(".html", buf, sizeof(buf))) return FALSE;
	}

	// s
	if (openmode) {	// VKvZXƂċN
		if (windows_ver >= 0x0500) {
			/* ]gpĂ WinExec() ͎qvZX GetMessage() ܂ŐԂȂ̂
			   WItalk2 uEŰN܂œtĂ܂肪 */
			char	progname[BUFSIZE], progparam[BUFSIZE];
			parseCmdline(buf, progname, progparam);
			return execProcess(progname, progparam, url);
		} else {	// Win9xłparseCmdLineCommandLineToArgvW()Ȃ̂WinExec
			strcat(buf, " "); strcat(buf, url);
			if (WinExec(buf, SW_SHOW) <= 32) return FALSE;
			return TRUE;
		}
	}
	if (can_shell_exec) {	// shell-open ŋN
		return (HINSTANCE)32 < ShellExecute(NULL, "open", url, NULL, NULL, SW_SHOW);
	} else if (_mbsistr(buf, "Netscape.exe")) {
		DWORD idInst = 0;
		if (DMLERR_NO_ERROR == DdeInitialize(&idInst, (PFNCALLBACK)DdeCallback, APPCLASS_STANDARD | APPCMD_CLIENTONLY, 0)) {
			BOOL r = TRUE;
			HSZ hsz_service = DdeCreateStringHandle(idInst, "NETSCAPE", CP_WINANSI);
			HSZ hsz_topic = DdeCreateStringHandle(idInst, "WWW_OpenURL", CP_WINANSI);

			HCONV hconv = DdeConnect(idInst, hsz_service, hsz_topic, NULL);
			if (hconv == NULL) {
				r = FALSE;
			} else {
				char request[BUFSIZE];
				wsprintf(request, "%s,,0xFFFFFFFF,0x0,,,", url);
				HSZ hsz_request = DdeCreateStringHandle(idInst, request, CP_WINANSI);
				DdeClientTransaction(NULL, 0, hconv, hsz_request, CF_TEXT, XTYP_REQUEST, 10000, NULL);
				DdeFreeStringHandle(idInst, hsz_request);
				DdeDisconnect(hconv);
			}

			DdeFreeStringHandle(idInst, hsz_topic);
			DdeFreeStringHandle(idInst, hsz_service);
			DdeUninitialize(idInst);
			if (r) return TRUE;
		}
	}
	char commandline[BUFSIZE];
	lgRegistry::InterpretAssociatedCommandline(url, buf, commandline, sizeof(commandline));
	if (WinExec(commandline, SW_SHOW) <= 32) return FALSE;
	return TRUE;
}


// [fBNg@
BOOL lgFiles::MakeDirectory(const char *newdir)
{
  int len = strlen(newdir);
  char *buf = (char *)_alloca(len + 2);
  strcpy(buf, newdir);
  if (buf[len] != '/' && buf[len] != '\\')
  {
    buf[len++] = '\\';
    buf[len] = '\0';
  }
  char *s = buf;
  BOOL r = FALSE;
  while ((s = strpbrk(s, "/\\")))
  {
    char c = *s;
    *s = '\0';
    r = (_mkdir(buf) == 0);
    *s = c;
    s++;
  }
  return r;
}

