/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgKeyBindingsMap.h


#ifndef __lgKeyBindingsMap_h__
#define __lgKeyBindingsMap_h__


#include "lgWindows.h"


class lgKeyBindingsMap : lgWindow
{
  struct Message
  {
    int flag;
    UINT message;
    WPARAM wParam;
    LPARAM lParam;
  };
  
  Message vkey_map[256][8];
  Message char_map[256][2];
  
  lgKeyBindingsMap *tmp_map;

  // 𓾂
  HWND get_hwnd_dest(int flag);
  
public:
  enum {
    DestNone    = 0,
    DestParent  = 1, // eEBhE֑
    DestOwner   = 2, // I[i[EBhE֑
    DestSelf    = 3, // g̃EBhE֑
    Dest        = DestParent | DestOwner | DestSelf,
    wParamCode  = 1 << 2, // wParam ɃR[h (vkey  char)
    lParamCode  = 1 << 3, // lParam              V
    wParamShift = 1 << 4, // wParam  Shift, Control, Alt ̏
    lParamShift = 1 << 5, // lParam              V
  // wParamCode  wParamShift w肳ƁAShift  << 8 
  // lParamCode  lParamShift w肳ƁAShift  << 8 
  };
  enum {
    Shift   = 1 << 0,
    Control = 1 << 1,
    Ctrl    = 1 << 1,
    Alt     = 1 << 2,
  };
  
  lgKeyBindingsMap(HWND hwnd);
  lgKeyBindingsMap(const lgKeyBindingsMap &other);
  
  // map NA
  void Clear(void);

  // vkey_map ւ̊蓖 (w肳ꂽ shift L[݂̂ꂽ)
  void SetVKey(int vk_code, int shift,
			 int flag, int message,
			 WPARAM wParam = 0, LPARAM lParam = 0);
  
  // vkey_map ւ̊蓖 (w肳ꂽ shift L[Ă΂悢)
  void SetVKeyOr(int vk_code, int shift,
			   int flag, int message,
			   WPARAM wParam = 0, LPARAM lParam = 0);

  // vk_codes ɗ񋓂Ă鉼zL[R[h̊蓖
  void SetVKeyOver(BYTE *vk_codes, int n, int shift,
			     int flag, int message,
			     WPARAM wParam = 0, LPARAM lParam = 0);
  
  // char_map ւ̊蓖
  void SetChar(int char_code, int shift,
			 int flag, int message,
			 WPARAM wParam = 0, LPARAM lParam = 0);
  
  // char_map ւ̘A蓖
  void SetCharOver(int char_code_from, int char_code_to, int shift,
			     int flag, int message,
			     WPARAM wParam = 0, LPARAM lParam = 0);
  
  // char_codes ɗ񋓂ĂR[h̊蓖
  void SetCharOver(char *char_codes, int n, int shift,
			     int flag, int message,
			     WPARAM wParam = 0, LPARAM lParam = 0);
  
  //  lgKeyBindingsMap ̃Rs[
  lgKeyBindingsMap &Copy(const lgKeyBindingsMap &other);
  
  // bZ[WnhO

  //  TRUE
  BOOL KeyDown(int vk_code);
  BOOL SysKeyDown(int vk_code);
  
  //  TRUE
  BOOL Char(char char_code, BOOL is_alt_pressed = FALSE);
  BOOL SysChar(int vk_code);
  
  // ꎞIɃL[}bv؂ւ
  lgKeyBindingsMap *SetTmpMap(lgKeyBindingsMap *tmp_map);
};


#endif // __lgKeyBindingsMap_h__
