/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgWindows.h


#pragma	once

#include	<stdio.h>
#include	<string.h>
#include	<malloc.h>

#include	<windows.h>
#include	<windowsx.h>
//#include	<afxres.h>
#include	<commctrl.h>

// add by sept (2002/6/6)
#include	<crtdbg.h>
#include	"Trace.h"

#include	<map>
using namespace std;

#define		BUFSIZE 1024
#define		ArrayNum(a) (sizeof(a) / sizeof(a[0]))



///////////////////////////////////////////////////////////////////////////////
// lgWindows


#if 0
// WinMain ǂłs邱
#define lgWindows_Main \
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, \
			     LPSTR lpszCmdLine, int nCmdShow) \
{ \
\
	/* Waffle 0.1.2: DllMain ŏ */ \
	DllMain(GetModuleHandle(0), DLL_PROCESS_ATTACH, 0); \
    int result = lgWindows::Main(__argc, __argv); \
	DllMain(GetModuleHandle(0), DLL_PROCESS_DETACH, 0); \
	return result; \
}
#endif


class lgWindows
{
	friend BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved);

	static HINSTANCE hinst;     // CX^Xnh
	static HINSTANCE lg_hinst;  // libgana  hinst
	static BOOL      is_nt;     // OS  NT ǂ
	static BOOL      is_nt_351; // OS  NT3.51 ǂ

	// libgana  DllMain Ăяo
	static BOOL init(HINSTANCE _lg_hinst);
	static BOOL end(void);

	static map<int, char*>*		resStringA;
	static map<int, wchar_t*>*	resStringW;
	static HANDLE				resStringMutexA;
	static HANDLE				resStringMutexW;

public:
	static const HINSTANCE hInst   (void) { return GetModuleHandle(0);/*hinst;*/ }
	static const HINSTANCE lg_hInst(void) { return GetModuleHandle(0);/*lg_hinst;*/ }
	static const BOOL      IsNT351 (void) { return is_nt_351; }
	static const BOOL      IsNT    (void) { return is_nt; }

	// WinMain Ăяo
	static int Main(int argc, char *argv[]);

	// O
	static const char *TheName(void);

	// LoadString ̎g₷`
	static char* LoadString(int id);
	static wchar_t* LoadStringW(int id);

	// ChooseColor ̊ȈՔ
	static BOOL ChooseColor(HWND hwnd_owner, COLORREF &color);

	// WR\[쐬
	static BOOL AllocStdConsole(BOOL text_mode = TRUE);

	// ImageList ǂݍ
	static HIMAGELIST LoadImageList(int rBitmap16, int rBitmap256 = -1, int width = 16);
};


///////////////////////////////////////////////////////////////////////////////
// lgGDI


class lgGDI : public lgWindows
{
public:
	static BOOL HasPalette(void);
	static int BitsParPixel(void);
};


///////////////////////////////////////////////////////////////////////////////
// lgVersion


class lgVersion : public lgWindows
{
	static char *lg_version_buf;	// libgana.dll ̃o[W
	static char *version_buf;		// dll Ăяoo[W
	static const char *vc[9];		// o[WJeS

	friend class lgWindows;

	static BOOL init(void);
	static BOOL end(void);
  
public:
	enum VersionCategory
	{
		Comments,
		CompanyName,
		FileDescription,
		FileVersion,
		InternalName,
		LegalCopyright,
		OriginalFilename,
		ProductName,
		ProductVersion,
	};

	// o[W
	static char *GetVersionString(VersionCategory v, const char *_version_buf);
	// ̃\tgEFÃo[W
	static char *GetVersionString(VersionCategory v){ return GetVersionString(v, version_buf); }
	// libgana ̃o[W
	static char *lgGetVersionString(VersionCategory v){ return GetVersionString(v, lg_version_buf); }

	// ̃\tgEFÃt@Co[W
	static BOOL GetVersionNo(int *v, const char *_version_buf);
	// ̃\tgEFÃo[Wԍ
	static BOOL GetVersionNo(int *v){ return GetVersionNo(v, version_buf); }
	// libgana ̃o[Wԍ
	static BOOL lgGetVersionNo(int *v){ return GetVersionNo(v, lg_version_buf); }
};


///////////////////////////////////////////////////////////////////////////////
// lgCtl3d (NT3.51 ł 3D Rg[𗘗p)


class lgCtl3d : public lgWindows
{
	static HMODULE hmodule;

	friend class lgWindows;

	static BOOL init(void);
	static BOOL end(void);

public:
	typedef BOOL (*_register     )(HINSTANCE);
	typedef BOOL (*_unregister   )(HINSTANCE);
	typedef BOOL (*_auto_subclass)(HINSTANCE);
	typedef BOOL (*_color_change )(void);

	static _register      Register;
	static _auto_subclass AutoSubclass;
	static _color_change  ColorChange;
	static _unregister    Unregister;
	static BOOL IsLoaded(void) { return !!hmodule; }
};


#include "lgString.h"
#include "lgWindow.h"
