/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgcToolbar


#pragma	once

#include	"lgWindows.h"

class lgcToolbar : public lgWindow {

public:

	lgcToolbar(HWND _hwnd) : lgWindow(_hwnd) { }

	// Toolbar ̃{^̉ĂԂω
	LRESULT PressButton(int id, BOOL is_pressed) { return SendMessage(TB_PRESSBUTTON,  id, MAKELONG(is_pressed, 0)); }

	// Toolbar ̃{^̏Ԍ\^s\ω
	LRESULT IndeterminateButton(int id, BOOL is_indeterminate) {
		if (is_indeterminate) PressButton(id, FALSE);
		return SendMessage(TB_INDETERMINATE, id, MAKELONG(!!is_indeterminate, 0));
	}

	// Toolbar ̃{^̗L^Ԃω
	LRESULT EnableButton(int id, BOOL is_enable) { return SendMessage(TB_ENABLEBUTTON, id, MAKELONG(is_enable, 0)); }

	// Toolbar Ɋ֘AtĂ Tooltip ̃EBhEԂ
	HWND GetTooltips(void) { return (HWND)SendMessage(TB_GETTOOLTIPS); }

	// {^̐擾
	int GetButtonCount(void) { return (int)SendMessage(TB_BUTTONCOUNT); }

	// {^̃TCY擾
	int GetButtonRect(int i, RECT *rc) { return (BOOL)SendMessage(TB_GETITEMRECT, (WPARAM)i, (LPARAM)rc); }

	// XN[W (x, y) {^ ID Ԃ
	int HitTest(int x, int y);  

	// SẴ{^傫𒲂ׂ
	BOOL GetButtonsRect(RECT *rc);

	// TOOLBAR \[Xǂ ToolBar 쐬
	//
	//  hwnd_parent:  eEBhE
	//  rToolbar:     Toolbar̒`\[X
	//  rToolbar16:   Toolbar16F\[X (ʏrToolbarƓ)
	//  rToolbar256:  Toolbar256F\[X
	//  has_top_sep:  擪̌ǂ
	//  window_style: CreateWindow() ɓnEBhEX^C
	//
	static lgcToolbar* newCreate(HWND hwnd_parent, int rToolbar, int rToolbar16 = -1, int rToolbar256 = -1, BOOL has_top_sep = TRUE, long window_style = WS_CHILD | WS_VISIBLE | TBSTYLE_TOOLTIPS);
};
